package com.jobs.consumer.controller;

import com.jobs.consumer.feignclient.ProviderAppClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

import java.util.Map;

@RequestMapping("/consumer")
@RestController
public class ConsumerController {

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private ProviderAppClient providerAppClient;

    @RequestMapping("/getdata1/{id}")
    public Map GetData1(@PathVariable("id") int id) {

        //采用 restTemplate 调用 PROVIDER-APP 的接口
        String url = "http://PROVIDER-APP/provider/getdata/" + id;
        Map result = restTemplate.getForObject(url, Map.class);
        result.put("remark","采用 restTemplate 调用返回的结果");
        return result;
    }

    @RequestMapping("/getdata2/{id}")
    public Map GetData2(@PathVariable("id") int id) {

        //采用 feign 的接口中的方法，实现对 PROVIDER-APP 服务接口的调用
        Map result = providerAppClient.GetProviderData(id);
        result.put("remark","采用 feign 声明式接口调用返回的结果");
        return result;
    }
}
